Subject: Re: [PATCH v6 00/13] Introduce clar testing framework

From: Patrick Steinhardt <[email-masked]>
Date: Wed, 28 Aug 2024 16:03:02 +0200

On Wed, Aug 28, 2024 at 02:18:49PM +0100, Phillip Wood wrote:
> On 20/08/2024 15:02, Patrick Steinhardt wrote:
> > Hi,
> > 
> > this is another version of my patch series that introduces the clar
> > testing framework for our C unit tests.
> 
> I've left some comments on the code, most of them are points I made in the
> last round that received no response. My main concern is that the assertions
> offered by clar are not as convinent as the check_* macros.

Did you have a look at my reply at <ZsSTOczuGhT5zwoV@tanuki>, where I
responded to these concerns?

In summary: I'm aware that this is still a rough edge. I'd be happy to
follow up on this and improve usability of the assertions, but doing it
likely is a bit more involved, mostly because I want to upstream all
changes in this context. So I'd rather want to land a basic version
first, and then I'd iterate and improve asserts.

> What's the plan for converting our current tests if this gets merged? If we
> were to add wrappers that provide check_int() etc. that would greatly
> simplify the conversion. I think it would offer a more ergonomic api for
> writing new tests than the verbose and non-typesafe cl_assert_equal_i() and
> friends.

My plan would first be to let things cook for a bit while I sort out the
rough spots upstream. Once done and once we are sufficiently sure that
this is the direction to go I'm happy to do the conversion myself.

Whether we want to have wrappers... I dunno, I don't think the names are
all that bad. They have a clear namespace and say rather directly what
they are doing, which I value more than briefness (to a certain extent,
of course). The type safety is another topic though, and something I
will aim to address.

Thanks!

Patrick